<%@ page import="com.crystaldecisions.sdk.framework.IEnterpriseSession,
                 com.crystaldecisions.sdk.occa.infostore.IInfoStore,
                 com.crystaldecisions.sdk.exception.SDKException,
                 com.crystaldecisions.sdk.occa.infostore.IInfoObjects,
                 com.crystaldecisions.sdk.occa.infostore.IInfoObject"%>
<%@ page import="com.crystaldecisions.report.web.viewer.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.report.application.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.report.reportsource.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.report.data.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.report.exportoptions.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.report.lib.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.infostore.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.managedreports.*" %>
<%@ page import="com.crystaldecisions.sdk.framework.*" %>
<%@ include file="../viewers/opendocstartpage.inc" %>
<%@ include file="tools/utils.inc" %>
<%@ include file="tools/storage.inc" %>
<%
//documentXML.jsp
/////////////////////////////////////////////////////////////////////////////
//Description : main page executing the layout for the Document viewing feature
//Properties :
//	id : document
//	settings group : hardcoded
//	framed : YES
//	blocktypes :
//		VIEWDOC
//	XML TEMPLATE : to be fixed
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//first part: begining the layout initialization
// - describe the layout structure and content, recover these datas from request fields / session variables / user settings / fixed values
// - applying an optionnal layout command
// - updating session variables / phantom user settings
/////////////////////////////////////////////////////////////////////////////
String sLayoutID = "document";

//store this current page in session to handle browser's refresh button
//setVariable(request.getSession(), "extRedirectionURL", "documentXML.jsp");
//FR 95681, 101067 and 101077: see in webiHome.jsp to see how this is used
//webiSession.setValue("LastURL", "documentXML.jsp");

//settings reading
//UserSettingsManager userSettings = new UserSettingsManager(webiSession, pageContext, userWISettings, userRights);

//for the following variable, we read it prioritary in the request, under a generic name (used by a generic form)
String sLastLayout = getVariableFromRequest(request, "ctxLayout_last");
if (sLastLayout == null) sLastLayout = getVariable(request, "ctx" + sLayoutID + "Layout_last");
else if (sLastLayout.equals("fromSession")) sLastLayout = getVariable(request, "ctx" + sLayoutID + "Layout_last");
if (sLastLayout == null) sLastLayout = "";

String skinName = getVariable(request, "ctxLayout_skin");
if (skinName == null) {
	skinName = "skin_default";
//	skinName = userSettings.getUserSetting("", "LAYOUT", "SkinName", skinName);
	}

//save the current layout status to the session variables
setVariable(request.getSession(), "ctxLayout_skin", skinName);
setVariable(request.getSession(), "ctx" + sLayoutID + "Layout_last", sLastLayout);

/////////////////////////////////////////////////////////////////////////////
//second part: content instanciation and initialization
// - including blocks classes files
// - instanciating and initializing blocks according to the structure of the layout
// - applying and forwarding an optionnal block command
/////////////////////////////////////////////////////////////////////////////
SetErrorPage("../viewers/cecommon/errorpage.jsp");

%>
<%@ include file="components/viewdocCompFunc.inc" %>
<%@ include file="../viewers/cecommon/helper_js.inc" %>
<%!

    // Given the URL and grep the infoObject kind
public String getObjectKindFromURL (	IEnterpriseSession iEntSession,
					String cmdParam,
					String cmdParam2,
					javax.servlet.jsp.JspWriter out,
					HttpServletRequest request,
					HttpServletResponse response,
					HttpSession session)
throws Exception
{
    String [] stDocProps = CSVtoStringArray(cmdParam);	//[0]=name, [1]=id, [2]=repotype, [3]=doctype, [4]=SDK token, [5]=kind
    if (stDocProps[3].length() == 0 && stDocProps[5].length() == 0) {
        if (iEntSession != null) {
            try
            {
                // InfoStore
                IInfoStore iStore = (IInfoStore) session.getAttribute("CB1_IStore");
                if( iStore == null )
                {
                    iStore = (IInfoStore) iEntSession.getService("", "InfoStore");
                    session.setAttribute("CB1_IStore", iStore);
                }

                String sIdType = null;
                // Report ID
                String sParam_id = stDocProps[1];
                if (sParam_id != null) {
                    int comma = sParam_id.indexOf(',');
                    if (comma >= 0)
                        sIdType = sParam_id.substring(0, comma);
                        sParam_id = sParam_id.substring(comma+1, sParam_id.length());
                }

                // Report Instances
                String sDocName = stDocProps[0];

                // only do search if no id param in the query string
                if ((sParam_id.length() == 0 || sParam_id.equals("0")) && !sDocName.equals("untitled") && sDocName.length() > 0)
                {
                    String sParam_Path = null;
                    // before we decode, search for a %26 "an encoded &" and replace 
                    // it with a %2526, we are searching for a folder name that contains an '&'
		    // ensure we are only working with sPath=
                    int sPathStartIndex = cmdParam2.indexOf(PARAM_PATH + "=");   

		    if( sPathStartIndex >= 0 )
		    {                
                      int sPathEndIndex = cmdParam2.indexOf("&", sPathStartIndex);
                      if (sPathEndIndex < 0)
                    	  sPathEndIndex = cmdParam2.length();
                    
                      sParam_Path = cmdParam2.substring(sPathStartIndex + PARAM_PATH.length() + 1, sPathEndIndex);
                      int srtIndx = sParam_Path.indexOf("%26", sPathStartIndex);    
                    
                      boolean seenAmp = false;
                      if( srtIndx != -1 )
                      {	                    	
                    	seenAmp = true;
                    	sParam_Path = sParam_Path.replaceAll(new String("%26"), new String("%2526") );
                      }
                      sParam_Path = URLDecodeUTF8(sParam_Path);
                    
                    
                      // if we have seen an encoded & in the sPath decode again.
                      if( seenAmp ){
                    	  sParam_Path = sParam_Path.replaceAll(new String("%26"), new String("&") );                        
                      }           	             	                   
                    }	
                    // Pass in a null sType as sType should not be specified in this method
                    sParam_id = getReportID(sDocName, sParam_Path, iStore, response, session, out, null);
                }
                if (sParam_id.length() > 0) {
                 	// Pass in a null sType as sType should not be specified in this method
                    IInfoObject obj = getObjectFromID(iStore, sDocName, sParam_id, sIdType, null);
                    if (obj != null) {
                        // todo: put sParam_id into the URL?
                        String newCmdParam = stDocProps[0] + C_SEP + obj.getID() + C_SEP + stDocProps[2] + C_SEP + stDocProps[3] + C_SEP + stDocProps[4] + C_SEP + obj.getKind();
                        return newCmdParam;
                    }
                }
            }
            catch (SDKException e)
            {
                // do nothing for now
            }
        }
    }
    return cmdParam;
}
%>
<%

//extract an optionnal block command from query string
String sCmdBlock = getVariableFromRequest(request, "cmdBlock"); if (sCmdBlock==null) sCmdBlock = "";
String sCmd = getVariableFromRequest(request, "cmd");
String sCmdParam1 = getVariableFromRequest(request, "cmdP1");
String sCmdParam2 = getVariableFromRequest(request, "cmdP2");

String sCmdBlockMapped = new String(sCmdBlock);
if (sCmdBlock.equals("all")) sCmdBlockMapped = "doc";

//userSettings.setCurrentSettingsGroup("DOCUMENT");	//all setting read from here concerns "DOCUMENT"
// Get sKind if no doctype nor kind was specified
sCmdParam1 = getObjectKindFromURL(entSession, sCmdParam1, sCmdParam2, out, request, response, session);
String sDocId           = CSVtoStringArray(sCmdParam1)[1];
String sDocName          = CSVtoStringArray(sCmdParam1)[0];
String sDocType 	= CSVtoStringArray(sCmdParam1)[5];

ViewDoc viewdocBlock = new ViewDoc("doc", sLocale);

viewdocBlock.updateFromQuery(request);	//block update with query string cmd

viewdocBlock.applyCommand(sCmdBlockMapped, sCmd, sCmdParam1, sCmdParam2);	//apply an eventual block command

/////////////////////////////////////////////////////////////////////////////
//third part: generating the XML (non framed) or HTML (framed) result from content components
// - generating the XML header for this layout
// - generating HTML frameset if the layout is framed
// - retrieving the XML of every blocks contained in the layout (and store it in session variables if the layount is framed)
/////////////////////////////////////////////////////////////////////////////

// here we begin the generation of the XML result
// the XML will be produced in a StringBuffer to be transform at end
/*
StringBuffer sXMLResult = new StringBuffer(2048);
sXMLResult.append("<LAYOUT id='").append(sLayoutID).append("' isSubFrame='1' maincol='0' skin='").append(skinName).append("' lastLayout='").append(XMLEntityEncode(sLastLayout)).append("' filename='documentXML.jsp'>\n");
sXMLResult.append("<LOCALE code='").append(sLocale).append("' language='").append(sLanguage).append("' numseps='").append(XMLEntityEncode(sNumSeps)).append("' />");

//list the possible block type for this layout: used to include various unique outputs in the result (after XSLT)
sXMLResult.append("<BLOCKTYPES><VIEWDOC /></BLOCKTYPES>\n");

//begin the layout description

//the main part of the layout : blocks

//this layout has one row
//but this is framed layout, so the ROW is useless, commented
//sXMLResult.append("<ROW num='0'>\n");

sXMLResult.append("<COL num='0' width='*' maincol='y' status='s'><COLHEADER />\n");

//the viewdoc block is in the col ("main" col)
sXMLResult.append("<BLOCK id='doc' col='0' status='s' type='VIEWDOC' framed='y'>\n");
sXMLResult.append(viewdocBlock.getXML(true, false));
sXMLResult.append("<CONSTRAINT><MOVE up='0' down='0' left='0' right='0' /><VISIBILITY hide='0' zoom='0' min='1' normal='1' /></CONSTRAINT>\n");
sXMLResult.append("</BLOCK>\n");

//closing layout XML
sXMLResult.append("</COL>");	//</ROW>, see above
sXMLResult.append("</LAYOUT>");

/////////////////////////////////////////////////////////////////////////////
//fourth part: output
// - XSLT-izing the XML result if layout is not framed
// - or send the HTML frameset if the layout is framed
/////////////////////////////////////////////////////////////////////////////

//boolean bXSLOnBrowser = userSettings.isClientXSLT();
//writeXMLorHTML(request, response, pageContext, out, sXMLResult, "documentXSL.xsl", sLocale, precompiledXSLTemplates, bXSLOnBrowser);
//this page is a frameset. The XML calculated is stored in session, for the header frame (called and XSLTized via frameXML.jsp)
setVariable(request.getSession(), sLayoutID + "Frame000", sXMLResult.toString());
*/

    String sURL = viewdocBlock.getURL();	//get the URL of the viewer for the body frame
    Object fwdContext = request.getAttribute( "attr_context" );
    if( null != fwdContext && !"".equals( fwdContext ) )
        sURL = fwdContext + sURL;
    else
        sURL = context + sURL;
int iHeaderHeight = 42;	//by default, no header frame (actually the header frame will be 0px high)
//start   ADAPT00570362.
boolean bZabo = false;
String sUrl = "";
if( request.getParameter("bZabo") != null )
bZabo		=	request.getParameter("bZabo").equals("true") ? true :false;
if( !sDocType.equals("FullClient") ) bZabo =false;
	if(bZabo)  
	{
			
				String tmpURL	= request.getScheme()+ "://" + request.getServerName() + ":" +request.getServerPort()+request.getContextPath();
				String sUrlBase=tmpURL + "/InfoView/listing/reportList.do";
        		if (sUrlBase == null) {
        			sUrlBase = ""; // @todo : do something better here
        		}	
        	// Warning : check if ot her extensions are available in Infoview
        	// that is other busobj types can be displayed as type FullClient
        	String sDocExt = "rep"; 
        	sDocName = java.net.URLEncoder.encode (sDocName,"UTF-8");
        	sUrl = "../InfoView/plugin/crystalenterprise/FullClient/OpenZaboDocument.jsp?" +
			             "nDocId=" + sDocId+ "&sDocName=" + sDocName+ "&sDocExt=" + sDocExt + "&sUrlBase=" + sUrlBase;
        	response.sendRedirect(sUrl);
	    	
	}
/////
%>
<HTML><HEAD>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<TITLE><%="" /*getLocaleString(pageContext, "ID_IFV_PAGETITLE_DOCUMENT", sLocale, localeStrings)*/ %></TITLE>
<LINK REL="STYLESHEET" TYPE="text/css" HREF="../images/<%= skinName %>/style.css" TITLE="Default Style" />
<style type="text/css" SRC="../images/<%= skinName %>/style.css"></style>
<SCRIPT language="javascript">
try {
if (parent) {
	if (typeof(parent.layoutFileName) != "undefined") parent.layoutFileName = "documentXML.jsp";
	//initializing contextual help
	if (typeof(parent.helpSectionFileName) != "undefined") parent.helpSectionFileName = "";
	if (typeof(parent.helpSectionRootPath) != "undefined") parent.helpSectionRootPath = "";
	}
} catch(e){}

function asyncOpenDocument(url) {
	//specific for openDocument feature
	//this function initiate an asynchronous loading of the URL
	setTimeout("document.location.href='"+url+"'", 100);
}

//unique timestamp for manual history management for openDocument feature
var timeStamp = "<%=(new Date()).getTime() %>";

try{
if (typeof(parent.realignStacks) != "undefined") parent.realignStacks(timeStamp);
} catch (e){}
</SCRIPT>
</HEAD>
<%
if( !bZabo && sCmdParam1 != null) //start  ADAPT00570362.
{%>

<FRAMESET rows='*' frameborder='0' border='0'>
	<!--FRAME class="noborders" name='<%=sLayoutID%>Frame000h' src='frameXML.jsp?layoutID=<%=sLayoutID%>&frameID=000' frameborder=0 border=0 scrolling='no' noresize-->
	<FRAME class="noborders" name='<%=sLayoutID%>Frame000hb' src='<%=sURL%>' frameborder=0 border=0>
</FRAMESET>
</HTML>
<%}%>

